using System;
using System.Text;
using Unit4.CollectionsLib;

namespace ConsoleApplicationVector3
{
    class Program
    {
        static void Main(string[] args)
        {
            Vector<int> v1 = new Vector<int>();
            Random rnd = new Random();
            Console.Write("Random add items: ");
            for (int i = 1; i <= 10; i++)
            {
                int x = rnd.Next(51) - 20;
                v1.Add(x);
                Console.Write(x + ",");
            }
            Console.WriteLine();
            Vector<int> v4 = GetSmalls2(v1, 4);
            Console.WriteLine("v1: " + v1);
            Console.WriteLine("v4: " + v4);

            Console.WriteLine(v1);
            v1.Del(1);
            v1.Del(5);
            v1.Del(v1.Length());
            Console.WriteLine("v1: " + v1);
            v1 = Sort(v1);
            Console.WriteLine("v1: " + v1);
            Console.WriteLine();
            for (int i = 1; i <= v1.Length(); i++)
                v1.Set(i, i);

            for (int i = 1; i <= v1.Length(); i++)
                Console.Write(v1.Get(i) + ",");
            Console.WriteLine();

            Vector<int> v2 = new Vector<int>();
            v2.Add(-10);
            v2.Add(1);
            v2.Add(2);
            v2.Add(100);

            Vector<int> v3 = MulVec(v1, v2);
            Console.WriteLine("v1: " + v1);
            Console.WriteLine("v2: " + v2);
            Console.WriteLine("v3: " + v3);
            
            Console.ReadLine();
        }
        public static Vector<int> MulVec(Vector<int> v1, Vector<int> v2)
        {
            int sum = 0;
            Vector<int> v3 = new Vector<int>();

            for (int i = 1; i <= v2.Length(); i++)
                sum = sum + v2.Get(i);

            for (int i = 1; i <= v1.Length(); i++)
                v3.Add(v1.Get(i) * sum);

            return (v3);
        }

        public static Vector<int> GetSmalls(Vector<int> vec, int k)
        {
            //  
            Vector<int> tmpVec = new Vector<int>();
            for (int i = 1; i <= vec.Length(); i++)
                tmpVec.Add(vec.Get(i));

            for (int i = 1; i <= k; i++)
            {
                int minPlace = i;
                for (int j = i; j <= tmpVec.Length(); j++)
                {
                    if (tmpVec.Get(j) < tmpVec.Get(minPlace))
                        minPlace = j;
                }
                int min = tmpVec.Get(minPlace);
                tmpVec.Set(minPlace, tmpVec.Get(i));
                tmpVec.Set(i, min);
            }

            Vector<int> resVec = new Vector<int>();
            for (int i = 1; i <= k; i++)
                resVec.Add(tmpVec.Get(i));

            return (resVec);
        }

        // O(n^3) suumption: k~n
        public static Vector<int> GetSmalls2(Vector<int> vec, int k)
        {
            int[] a = new int[vec.Length()];

            for (int i = 0; i < vec.Length(); i++)
                a[i] = vec.Get(i + 1);

            for (int i = 0; i < k; i++)
            {
                int minPlace = i;
                for (int j = i; j < a.Length; j++)
                {
                    if (a[j] < a[minPlace])
                        minPlace = j;
                }
                int min = a[minPlace];
                a[minPlace] = a[i];
                a[i] = min;
            }

            Vector<int> resVec = new Vector<int>();
            for (int i = 0; i < k; i++)
                resVec.Add(a[i]);

            return (resVec);
        }

        // O(n^2)
        public static Vector<int> GetSmalls3(Vector<int> vec, int k)
        {
            int[] a = new int[vec.Length()];

            //   
            for (int i = 0; i < vec.Length(); i++)
                a[i] = vec.Get(i + 1);

            //  
            for (int i = 1; i <= vec.Length() - 1; i++)
            {
                for (int j = 0; j < a.Length - i; j++)
                {
                    if (a[j] > a[j + 1])
                    {
                        int tmp = a[j];
                        a[j] = a[j + 1];
                        a[j + 1] = tmp;
                    }
                }
            }

            Vector<int> resVec = new Vector<int>();
            //     -   
            for (int i = 0; i < k; i++)
                resVec.Add(a[i]);

            return (resVec);
        }

        public static Vector<int> Sort(Vector<int> vec)
        {
            Vector<int> sortedVec = new Vector<int>();

            for (int i = 1; i <= vec.Length(); i++)
                sortedVec.Add(vec.Get(i));

            for (int i = 1; i < sortedVec.Length(); i++)
                for (int j = 1; j <= sortedVec.Length() - i; j++)
                    if (sortedVec.Get(j) > sortedVec.Get(j + 1))
                    {
                        int tmp = sortedVec.Get(j);
                        sortedVec.Set(j, sortedVec.Get(j + 1));
                        sortedVec.Set(j + 1, tmp);
                    }

            return (sortedVec);
        }

        public static Vector<int> Sort2(Vector<int> vec)
        {
            int[] a = new int[vec.Length()];

            //   
            for (int i = 0; i < vec.Length(); i++)
                a[i] = vec.Get(i + 1);

            //  
            for (int i = 1; i <= vec.Length() - 1; i++)
            {
                for (int j = 0; j < a.Length - i; j++)
                {
                    if (a[j] > a[j + 1])
                    {
                        int tmp = a[j];
                        a[j] = a[j + 1];
                        a[j + 1] = tmp;
                    }
                }
            }

            //
            Vector<int> sortedVec = new Vector<int>();
            for (int i = 0; i < a.Length; i++)
                sortedVec.Add(a[i]);

            return (sortedVec);
        }

    }
}
