using System;
using System.Text;
using Unit4.CollectionsLib;
namespace ConsoleApplicationVector3
{
    class Vector <T>
    {
        
        private List<T> list;
        private int numOfItems;

        public Vector()
        {
            this.list = new List<T>();
            this.numOfItems = 0;
        }

        public void Add(T x)
        {
            this.list.Insert(null, x);
            this.numOfItems++;
        }

        public void Del(int place)
        {
            this.list.Remove(this.GetItemPos(place));
            this.numOfItems--;
        }

        public T Get(int place)
        {
            return (this.GetItemPos(place).GetInfo());
        }

        public void Set(int place, T x)
        {
            this.GetItemPos(place).SetInfo(x);
        }

        public int Length()
        {
            return (this.numOfItems);
        }

        public override String ToString()
        {
            Stack<T> stk = new Stack<T>();
            Node<T> pos = this.list.GetFirst();

            while (pos != null)
            {
                stk.Push(pos.GetInfo());
                pos = pos.GetNext();
            }

            String str = "";

            if (!stk.IsEmpty())
                str = str + stk.Pop();
            while (!stk.IsEmpty())
                str = str + "," + stk.Pop();

            return (str);
        }

        // :     
        private Node<T> GetItemPos(int place)
        {
            Node<T> pos = this.list.GetFirst();

            for (int i = 1; i <= this.numOfItems - place; i++)
                pos = pos.GetNext();

            return (pos);
        }
        
    } 
}
